{
 ************************************************************************************************************
 *                                                                                                          *
 *  AUTO-RECOVER NOTICE: This file was automatically recovered from an earlier Propeller Tool session.      *
 *                                                                                                          *
 *  ORIGINAL FOLDER:                                                                                        *
 *  TIME AUTO-SAVED:     20 hours, 35 minutes ago (8/1/2011 2:27:44 PM)                                     *
 *                                                                                                          *
 *  OPTIONS:             1)  RESTORE THIS FILE by deleting these comments and selecting File -> Save.       *
 *                           The existing file in the original folder will be replaced by this one.         *
 *                                                                                                          *
 *                           -- OR --                                                                       *
 *                                                                                                          *
 *                       2)  IGNORE THIS FILE by closing it without saving.                                 *
 *                           This file will be discarded and the original will be left intact.              *
 *                                                                                                          *
 ************************************************************************************************************
}  
''       S100 ConsoleIO board driver
''       John Monahan  (monahan@vitasoft.org)   5/25/2011
''

''      V28.0    5/25/2011      Corrected problem with DEL key
''      V28.1     8/2/2011      Added Int vector for key press input 
''      V28.2   10/18/2011      Fixed recognition of CTRL & ALT keys

''      To be done:-
''      Need to find how to detect the keyboard scan code and display it in the first pair of HEX displays

    
CON
    _clkmode = xtal1 + pll16x
    _xinfreq = 5_000_000

    '' VGA driver: video output pin
    video = 16

    '' RS-232 driver values:  rx and tx lines
    r0 = 31
    t0 = 30

    '' Keyboard clock and data
    kbd = 14
    kbc = 15

    BS = 8
    LF = 10
    CR = 13
    ESC = 27
  
VAR

  word  keyboard_char                    'Must be word because CTRL,ALT etc info is in high byte
  byte  keyboard_status
  byte  ch
  long  scankey
  word  palette[vga#bcnt_raw / 2]                       ' 2n aligned       
 
OBJ
    kb:         "Keyboard"              ' Keyboard driver
    ser0:       "FullDuplexSerial"      ' Full Duplex Serial Controller(s)
    vga:        "waitvid.100xP.ui"        

PUB main

    init_devices                                        ' One-time setup of Serial, VGA and Keyboard    
    vga.init

    vga.str(string(vga#ESC, "S"))                         ' scroll mode    

' Switch to colour per position mode.

    vga.setn(2, @palette{0})
    waitcnt(clkfreq + cnt)                              ' initialize terinal emulator object
    vga.str(string(vga#ESC, "c", %%3333, %%0003))       
    
    dira[7..0]~~                                        'Set P7-P0 to output

    dira[8]~~                                           'To keep console IN bit "Busy" while processing data, always out
    outa[8] := 0                                        'nothing right now 

    dira[9]~                                            'DATA_IN_BUSY is read via this pin, alwauys in
    
    dira[10]~~                                          'Keyboard character available status bit, always out
    outa[10] := 0                                       'nothing right now

    dira[11]~                                           'DATA_OUT_BUSY is read via this pin, alwauys in

    dira[12]~~                                          'Pin 12 for interrupt vector to S-100 bus -  output
    outa[12] := 1                                       'Will be edge triggered on S-100 bus for MS-DOS/BIOS Monitor. Off initially

    dira[13]~~                                          'Pin for buzzer/bell - output
    outa[13] := 1

 
    dira[24]~~                                          'To latch U47
    outa[24] := 1                                       'Nothing initially
    dira[25]~~                                          'To latch U46
    outa[25] := 1                                       'Nothing initially

    dira[26]~~                                          'Set P26 to output for HEX display (keyboard key code)
    outa[26] := 1                                       'Nothing to latch right now
    dira[27]~~                                          'Set P27 to output for HEX display (keyboard ASCII translated key)
    outa[27] := 1                                       'no strobe or latch yet
                                                         
                                                        'P14 & P15 are for keyboard data & clock signals
    
    keyboard_status := 0                                'Flag as nothing there
    
    repeat

             if keyboard_status == 0                            'If nothing so far
                
                 keyboard_char := kb.key                        'Check if something in que (Note word returned)

                                                                                                                                                  
                 if keyboard_char.byte[0] <> 0                  'non-zero means we have a character

                                    
                         keyboard_status := $ff                  'set flag we have a character

                         if keyboard_char.byte[0] == $c8         'Backspace keyboard key
                             keyboard_char.byte[0] := $08
                             
                         if keyboard_char.byte[0] == $C9         'Delete Keyboard key (on Number Pad with NUM Lock Off) 
                             keyboard_char.byte[0] := $7F
                                                                 '(Note you can play around here adding Characters or whole strings for the Function keys etc.)

                         if keyboard_char.byte[0] == $CB         'ESC key
                                keyboard_char.byte[0] := $1B

                                               
                         if keyboard_char.byte[0] == $DC          'Print Scr key   ---> to the IBM BIOS as $1CH (^\)  
                             keyboard_char.byte[0] := $1C

                                                                   'Check for Ctrl+ALT+ DEL ---> to the IBM BIOS as $1DH (^]
                         if((keyboard_char.byte[1] == $06) & (keyboard_char.byte[0] == $7F)) '
                                                                                              
                                 keyboard_char.byte[0] := $1D      'Check for Alt in Ctrl/Alt/Del key will be sent to the IBM BIOS

                                                                    
                         if keyboard_char.byte[1] == $02           'Check for Crtl (only)                  

                             if keyboard_char.byte[0] == $DF       'Check for NUM_LOCK  (On PC This pauses the computer)
                                 keyboard_char.byte[0] := $1E      'Ctrl/BREAK = Ctrl+NUM-LOCK key will be sent to the IBM BIOS as $1EH (^^)      
                        
                             else
                                    keyboard_char.byte[0] &= $1F    'If so convert everything to ^ characters


                         if keyboard_char.byte[1] == $04            'Is the ALT key to be recognized
                                 keyboard_char.byte[0] |= $80       'If so set bit 7 for my PC-BIOS. (This is only relevent for the IBM-PC BIOS)
                                 
                                                        

                         outa[7..0] := keyboard_char.byte[1]      'Update the HEX display, Ctrl=02,ALT=04, (Win not done) bits in high HEX display
                         outa[26] := 0                            'Pulse line to latch data into HEX display
                         outa[26] := 1       
                                
                         outa[7..0] := keyboard_char.byte[0]      'Update the HEX display
                         outa[27] := 0                            'Pulse line to latch data into HEX display
                         outa[27] := 1
                         
                         outa[24] := 0                            'Also latch data into U47
                         outa[24] := 1

                                               
                         outa[10] := 1                  'Only then do we flag S-100 bus as something there (bit 1 of port 14H = 1)
                                                        'This is a little subtle. The strobe pulse from P24 will clock the 74LS74
                                                        'so StatusInBusy goes high. This will go to pin 2 of U39A. However only when
                                                        'P10 goes high on pin 1 of U39A does the status appear on the S100 bus indicating
                                                        'the board has a new keyboard character to be read. However the instant the S-100
                                                        'bus reads the data from U47 its pin 1 immediatly resets the 74LS74 removing the character available
                                                        'status bit from the S-100 bus.  The reason we have the "double" requirement for a
                                                        'status bit is because the p24 pulse (using Spin) is too long, causing the S-100 bus
                                                        'with a fast (eq 10Mhz Z80) to pick up two characters instead of one.

                         outa[12] := 0                  'Now pulse the S-100 vector Int line (used by MS-DOS BIOS)
                         waitcnt(clkfreq / 10 + cnt)    'wait for .1 seconds (100 ms) just in case -- though the 8259A should be edge triggered
                         outa[12] := 1                  'This way we will see the Int LED actully flash on the board.
                         
                                                         
             if keyboard_status == $ff                  'If we have a keyboard character
                                         
                 if ina[9] == %0                        'P9 Low, so character has now been read by S-100 bus (INPUT_ENABLE* went low resetting 7474, DATA_IN_BUSY)

                       outa[10] := 0                    'Flag S-100 bus no more characters available to be read
                       
                       keyboard_status := 0             'For next time     
                       
                      
          
            if ina[11] == %1                            'Is there an S-100 bus character WRITE request (P11, LATCHED_OUTPUT_ENABLE high)

                  outa[8] := 1                          'Raise Console Busy bit (P8 to pin 3 of LS02),
                                                        'this will lower set bit 2 of Console OUT Status port to 0

                  dira[7..0]~                           'Set P7-P0 to INPUT mode

                  outa[25] := 0                         'Lower 74LS373 OE pin (to place data on P0-P7 lines)
                                                        'Note this will also clear U44, LATCHED_OUTPUT_ENABLE, but because P8 is high/busy bit 2
                                                        'back to S-100 system is still low. This is necessary because the pulse signal from P25
                                                        'is long enough that a 10MHz Z80 can squeeze in another invalid console busy status bit check
                                                        
                  ch := ina[7..0]                       'Get the data                 
                  outa[25] := 1                         'Raise OE pine when done.

                  vga.out(ch)   

                  dira[7..0]~~                                                  'Set P7-P0 back to OUTPUT
                        
                  outa[8] := 0                                                  'We are ready for next character
                   
                                                                             


'' Process bytes from our host port
PRI doSerial0 | c

    ' Consume bytes until FIFO is empty
    repeat
        c := ser0.rxcheck
        ser0.tx(c)

'' One-time initialization of terminal driver state
PRI init_devices

    ' Initialize RS-232 ports.  We'll shortly be restarting them
    '  after we choose a config
    ser0.start(r0, t0, 0, 9600)

    ' Start VGA output driver  <<<<<<<<<<< Inactivate simple VGA output for VT100 Mode >>>>>>>>>>>>
   ' text.start(video)
   ' text.cls

    ' Start Keyboard Driver
    kb.start(kbd, kbc)

'' Read and dispatch a keystroke


    